clc;
clear;
addpath(pathname); % pathname is the path of raw data file.
load('ten_time_five_fold.mat'); %10 times 5 cross validation.
lab = [-ones(1,47),ones(1,45)]; % labels of subjects.

M = 170; % the number of volumes.
d = 10; % the order of central moment feature. In our cause, d = [1:1:10].
num = 92; %the number of Subjects.
for k1 = 1 : 8
    W = 20+10*k1; % the length of sliding window.
    for k2 = 1 : 8
        s = 2*k2; % the translation step.
        K = floor((M-W)/s)+1; %the number of sliding windows.
        feature = zeros(6670,92);
        for i = 1:num
            Subject_i = strcat('Subject_',num2str(i),'.csv');
            D = csvread(Subject_i);
            subnetworks = zeros(116,116,K);
            for j = 1:K
                idx1 = (j-1) * s + 1;
                idx2 = (j-1) * s + W;
                subnetworks(:,:,j) = corr(D(idx1:idx2,1:116));
            end
            CM = threeD_CM(subnetworks,d);% get d-th order central moment feature.
            for t = 1 : length(CM) % remove diagonal elements
                tmp = CM(:,t);
                tmp(t) = [];
                tmp_CM(:,t) = tmp; 
            end
            Vectorize_CM = Triple(corr(tmp_CM)); % Calculate high-order FC matrix and vectorize it.
            feature(:,i) = Vectorize_CM(:,3); % Feature extraction
        end

        %
        for k3 = 1:10
            clc;
            fprintf('k1=%d,k2=%d,k3=%d\n',k1,k2,k3);
            Lab_A = Lab_num_A{k3};
            Lab_N = Lab_num_N{k3};
            temp=FCLASS5(feature,lab,Lab_A,Lab_N);
            ACC(k1,k2,k3)=temp(1); % the ACC
        end
    end
end
Final_ACC = mean(ACC,3); % the final ACC.